#pragma once
#include "body.h"
#include "star_system.h"

class Frame;
class Planet : public Body {
public:
  Planet(StarSystem::SBody::SubType);
  virtual ~Planet(void);
  virtual void SetPosition(vector3d p);
  virtual vector3d GetPosition(void);
  void SetRadius(double radius);
  double GetRadius(void) { return m_radius; }
  virtual void Render(const Frame* camFrame);
  virtual void TransformToModelCoords(const Frame* camFrame);
  virtual void TransformCameraTo(void) {};
  virtual void SetFrame(Frame* f);
private:
  vector3d m_pos;
  double m_radius;
  dGeomID m_geom;
  StarSystem::SBody::SubType m_subtype;
};

