#pragma once
#include "body.h"
#include "star_system.h"

class Frame;

class Star: public Body {
public:
  Star(StarSystem::SBody::SubType subtype);
  virtual ~Star(void) { };
  virtual void SetPosition(vector3d p);
  virtual vector3d GetPosition(void);
  void SetRadius(double radius) { m_radius = radius; }
  double GetRadius(void) { return m_radius; }
  virtual void Render(const Frame* camFrame);
  virtual void TransformToModelCoords(const Frame* camFrame);
  virtual void TransformCameraTo(void) { };

private:
  StarSystem::SBody::SubType m_subtype;
  vector3d  m_pos;
  double    m_radius;
};

