#pragma once
#include "libs.h"
#include "gui.h"

/*
 * For whatever draws into the main area of the screen.
 * Eg:
 *  Game 3D view.
 *  System map.
 *  Sector map.
 */
 class View : public Gui::Fixed {
 public:
  View(void) : Gui::Fixed(0, 64, 640, 416) {
    m_rightButtonBar = new Gui::Fixed(512, 0, 128, 26);
    m_rightButtonBar->SetBgColor(.65, .65, .65);

    m_rightRegion2 = new Gui::Fixed(517, 26, 122, 17);
    m_rightRegion2->SetTransparency(true);
  }
  virtual ~View(void) { delete m_rightButtonBar; delete m_rightRegion2; }
  virtual void ShowAll(void) {
    m_rightButtonBar->ShowAll();
    m_rightRegion2->ShowAll();
    Gui::Fixed::ShowAll();
  }
  virtual void HideAll(void) {
    m_rightButtonBar->HideAll();
    m_rightRegion2->HideAll();
    Gui::Fixed::HideAll();
  }
  /* Called before Gui::Draw will call widget ::Draw methods. */
  virtual void Draw3D(void) = 0;
  /* For checking key states, mouse stuff. */
  virtual void Update(void) = 0;
protected:
  /* Each view can put some buttons in the bottom right of the cpanel. */
  Gui::Fixed* m_rightButtonBar;
  //Gui::Fixed* m_rightRegion1;
  Gui::Fixed* m_rightRegion2;
 };

